
/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "MonochromeLib.h"
#include "stdlib.h"
#include "stdio.h"
#include "fxlib.h"
#include "sprites.h"
#include "syscall.h"

#define __KEYBIOS_H__
#include "fxlib.h"
#define KEY_CHAR_0 71
#define KEY_CHAR_1 72
#define KEY_CHAR_2 62
#define KEY_CHAR_3 52
#define KEY_CHAR_4 73
#define KEY_CHAR_5 63
#define KEY_CHAR_6 53
#define KEY_CHAR_7 74
#define KEY_CHAR_8 64
#define KEY_CHAR_9 54
#define KEY_CHAR_DP 61
#define KEY_CHAR_EXP 51
#define KEY_CHAR_PMINUS 41
#define KEY_CHAR_PLUS 42
#define KEY_CHAR_MINUS 32
#define KEY_CHAR_MULT 43
#define KEY_CHAR_DIV 33
#define KEY_CHAR_FRAC 75
#define KEY_CHAR_LPAR 55
#define KEY_CHAR_RPAR 45
#define KEY_CHAR_COMMA 35
#define KEY_CHAR_STORE 25
#define KEY_CHAR_LOG 66
#define KEY_CHAR_LN 56
#define KEY_CHAR_SIN 46
#define KEY_CHAR_COS 36
#define KEY_CHAR_TAN 26
#define KEY_CHAR_SQUARE 67
#define KEY_CHAR_POW 57
#define KEY_CTRL_EXE 31
#define KEY_CTRL_DEL 44
#define KEY_CTRL_AC 32
#define KEY_CTRL_FD 65
#define KEY_CTRL_EXIT 47
#define KEY_CTRL_SHIFT 78
#define KEY_CTRL_ALPHA 77
#define KEY_CTRL_OPTN 68
#define KEY_CTRL_VARS 58
#define KEY_CTRL_UP 28
#define KEY_CTRL_DOWN 37
#define KEY_CTRL_LEFT 38
#define KEY_CTRL_RIGHT 27
#define KEY_CTRL_F1 79
#define KEY_CTRL_F2 69
#define KEY_CTRL_F3 59
#define KEY_CTRL_F4 49
#define KEY_CTRL_F5 39
#define KEY_CTRL_F6 29
#define KEY_CTRL_MENU 48
#ifndef OS2Change
#define OS2Change
#ifndef OS2Change_GetOS2
#define OS2Change_GetOS2
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
int OSVersionAsInt(void)
{
    unsigned char mainversion;
    unsigned char minorversion;
    unsigned short release;
    unsigned short build;
    GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
    return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
#endif
#ifndef OS2Change_Keyboard
#define OS2Change_Keyboard
void delay(void)
{
    char i;
    for (i=0; i<5; i++){};
}
unsigned char CheckKeyRow(unsigned char code)
{
    unsigned char result=0;
    short*PORTB_CTRL=(void*)0xA4000102;
    short*PORTM_CTRL=(void*)0xA4000118;
    char*PORTB=(void*)0xA4000122;
    char*PORTM=(void*)0xA4000138;
    char*PORTA=(void*)0xA4000120;
    short smask;
    char cmask;
    unsigned char column, row;
    column = code>>4;
    row = code &0x0F;
    smask = 0x0003 << (( row %8)*2);
    cmask = ~( 1 << ( row %8) );
    if(row <8)
    {
        *PORTB_CTRL = 0xAAAA ^ smask;
        *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
        delay();
        *PORTB = cmask;
        *PORTM = (*PORTM & 0xF0 ) | 0x0F;
    }
    else
    {
        *PORTB_CTRL = 0xAAAA;
        *PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
        delay();
        *PORTB = 0xFF;
        *PORTM = (*PORTM & 0xF0 ) | cmask;
    }
    
    delay();
    result = (~(*PORTA))>>column & 1;
    delay();
    *PORTB_CTRL = 0xAAAA;
    *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
    delay();
    *PORTB_CTRL = 0x5555;
    *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
    delay();
    
    return result;
}

unsigned char KeyDown(unsigned char keycode)
{
    unsigned short key[8];
    const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
    if(isOS2)
    {
        unsigned char row = keycode%10;
        memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
        
        return (0 != (key[row >> 1] & 1 << keycode / 10 - 1 + ((row & 1) << 3)));
    }
    else
    {
        return CheckKeyRow((keycode % 10) + ((keycode / 10 - 1) << 4));
    }
}
unsigned char GetKeyMod(unsigned int *key)
{
    unsigned char x, ret;
    
    ret = GetKey(key);
    
    for(x = 0; x < 80; x++)
    {
        if(KeyDown(x))
        {
            *key = x;
            break;
        }
    }
    return ret;
}
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)
#define GetKey(x) GetKeyMod(x)
#endif
#endif

const char *pensees[5]={Peq,Pdormir,Pmanger,Pjouer,Plaver};
const char *chats[7]={ chatnormal, chatfatigue, chatgros, chatmaigre, chatpascontent, chatsale, mort };
const char *bouffe[6]={riz,burger,gateau,soupe,lait,soda};
double points[]={0,0,0,0,0};
int i=0,animal=0,numero=1,pensee=0,key=0,fd=0,fdbis=0,partie=0;
double eq=0.0,en=0.0,f=0.0,hu=0.0,hy=0.0;
char str[100];
unsigned int hours,mins,secs,msecs;
unsigned int timeactu[]={0,0,0,0},timeref[]={0,0,0,0},timeecou[]={0,0,0,0};
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    FONTCHARACTER Points[]={'\\','\\','f','l','s','0','\\','p','o','i','n','t','s','.','t','a','m',0};
    FONTCHARACTER PathName[]={'\\','\\','f','l','s','0','\\','t','e','m','p','s','.','t','a','m',0};
    partie=accueil();
        if(partie==0){
            points[0]=50.0;
            points[1]=100.0;
            points[2]=100.0;
            points[3]=100.0;
            points[4]=100.0;
            Bfile_CreateFile(Points,1000);
            Bfile_CreateFile(PathName, 1000);
            RTC_GetTime(&hours, &mins, &secs, &msecs);
            timeref[0]=hours;
            timeref[1]=mins;
            timeref[2]=secs;
            timeref[3]=msecs;
            fd=Bfile_OpenFile(PathName, _OPENMODE_WRITE);
            Bfile_WriteFile(fd, &timeref, sizeof(timeref));
            Bfile_CloseFile(fd);
            fdbis=Bfile_OpenFile(Points, _OPENMODE_WRITE);
            Bfile_WriteFile(fdbis, &points, sizeof(points));
            Bfile_CloseFile(fdbis);
            
        ML_clear_vram();
        ML_bmp_or(oeufnoir,60,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir,58,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir,62,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir,60,27,9,10);
        ML_display_vram();
        Sleep(50);
        
        ML_clear_vram();
        ML_bmp_or(oeufnoir2,60,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir2,58,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir2,62,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir2,60,27,9,10);
        ML_display_vram();
        Sleep(50);
        
        ML_clear_vram();
        ML_bmp_or(oeufnoir3,60,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir3,58,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir3,62,27,9,10);
        ML_display_vram();
        Sleep(50);
        ML_clear_vram();
        ML_bmp_or(oeufnoir3,60,27,9,10);
        ML_display_vram();
        Sleep(50);
        
        ML_clear_vram();
        ML_bmp_or(oeufnoir4,60,27,9,10);
        ML_display_vram();
        Sleep(500);
        
    }
    else{
        fdbis=Bfile_OpenFile(Points,_OPENMODE_READ);
        Bfile_ReadFile(fdbis,points,40,-1);
        Bfile_CloseFile(fdbis);
        
        fd=Bfile_OpenFile(PathName,_OPENMODE_READ);
        Bfile_ReadFile(fd,timeref,16,-1);
        Bfile_CloseFile(fd);
        
        RTC_GetTime(&hours, &mins, &secs, &msecs);
        timeactu[0]=hours;
        timeactu[1]=mins;
        timeactu[2]=secs;
        timeactu[3]=msecs;
        for(i=0;i<4;i++)
        {
            timeecou[i]=0;
            timeecou[i]=timeactu[i]-timeref[i];
            timeref[i]=timeactu[i];
        }
        if(timeecou[0]<0)timeecou[0]=timeecou[0]+24;
        Bfile_DeleteFile(PathName);
        Bfile_CreateFile(PathName, sizeof(timeref));
        fd=Bfile_OpenFile(PathName, _OPENMODE_WRITE);
        Bfile_WriteFile(fd, &timeref, sizeof(timeref));
        Bfile_CloseFile(fd);
        for(i=0;i<5;i++)
        {
            points[i]=points[i]-timeecou[0];
        }
        
    }

    
    
    key=0;
    while(key!=KEY_CTRL_F6)
    {
        for(i=0;i<5;i++)
        {
            if(points[i]>100.0)points[i]=100.0;
            if(points[i]<-50.0)points[i]=-50.0;
        }
        
        animal=emotion(points);
        pensee=(sentiment(points))-1;
        ML_clear_vram();
        if(points[0]<0)ML_bmp_or(Aeq,3,3,20,20);
        if(points[1]<0)ML_bmp_or(Aen,25,3,20,20);
        if(points[2]<0)ML_bmp_or(Af,105,3,20,20);
        if(points[3]<0)ML_bmp_or(Ahu,3,25,20,20);
        if(points[4]<0)ML_bmp_or(Ahy,105,25,20,20);
        ML_bmp_or(fond,0,0,128,64);
        ML_bmp_or(chats[animal],39,7,50,50);
        
        if(pensee>-1)ML_bmp_or(pensees[pensee],75,2,20,20);
        ML_display_vram();
        key=0;
        GetKey(&key);
        if(animal==6)
        {
            Bfile_DeleteFile(PathName);
            Bfile_DeleteFile(Points);
            key=KEY_CTRL_F6;
        }
        switch(key)
        {
            case KEY_CTRL_F1:
                numero=manger();
                switch (numero)
            {
                case 1:
                    points[0]=points[0]+10.0;
                    points[1]=points[1]+10.0;
                    points[2]=points[2]+100.0;
                    points[3]=points[3]-5.0;
                    points[4]=points[4]-30.0;
                    break;
                case 2:
                    points[0]=points[0]-20.0;
                    points[1]=points[1]+10.0;
                    points[2]=points[2]+80.0;
                    points[3]=points[3]+10.0;
                    points[4]=points[4]-30.0;
                    break;
                case 3:
                    points[0]=points[0]-10.0;
                    points[1]=points[1]+10.0;
                    points[2]=points[2]+70.0;
                    points[3]=points[3]+10.0;
                    points[4]=points[4]-30.0;
                    break;
                case 4:
                    points[0]=points[0]+20.0;
                    points[1]=points[1]+10.0;
                    points[2]=points[2]+80.0;
                    points[3]=points[3]-5.0;
                    points[4]=points[4]-30.0;
                    break;
                case 5:
                    points[0]=points[0]+5.0;
                    points[1]=points[1]+10.0;
                    points[2]=points[2]+20.0;
                    points[3]=points[3]+5.0;
                    points[4]=points[4]-30.0;
                    break;
                case 6:
                    points[0]=points[0]-2.0;
                    points[1]=points[1]+10.0;
                    points[2]=points[2]+10.0;
                    points[3]=points[3]+5.0;
                    points[4]=points[4]-30.0;
                    break;

            }
                key=0;
                break;
            case KEY_CTRL_F2:
                points[4]=points[4]+30.0;
                break;
            case KEY_CTRL_F3:
                numero=jeux();
                switch(numero)
            {
                case 1:
                    numero=0;
                    numero=jeu_balle();
                    points[0]=points[0]+numero;
                    points[1]=points[1]-20.0;
                    points[2]=points[2]-10.0;
                    points[3]=points[3]+numero;
                    points[4]=points[4]-20.0;
                    break;
            }
                key=0;
                break;
            case KEY_CTRL_F4:
                for(i=0;i<3;i++)
                {
                ML_clear_vram();
                ML_bmp_or(chatdort,39,7,50,50);
                ML_display_vram();
                Sleep(400);
                ML_clear_vram();
                ML_bmp_or(chatdort2,39,7,50,50);
                ML_display_vram();
                Sleep(400);
                ML_clear_vram();
                ML_bmp_or(chatdort3,39,7,50,50);
                ML_display_vram();
                Sleep(400);
                }
                points[1]=points[1]+100.0;
                points[2]=points[2]-80.0;
                points[3]=points[3]-60.0;
                points[4]=points[4]-60.0;
                break;
            case KEY_CTRL_F5:
                douche();
                points[0]=points[0]+10.0;
                points[1]=points[1]-20.0;
                points[2]=points[2]-20.0;
                points[3]=points[3]+20.0;
                points[4]=points[4]+80.0;
                break;
            case KEY_CTRL_OPTN:
                ML_clear_vram();
                ML_bmp_or(stats,0,0,128,64);
                ML_display_vram();
                eq=(points[0]/100.0)*106.0;
                en=(points[1]/100.0)*106.0;
                f=(points[2]/100.0)*106.0;
                hy=(points[4]/100.0)*106.0;
                hu=(points[3]/100.0)*49.0;
                
                if(eq<0.0)
                {
                    eq=0.0;
                }
                if(en<0.0)
                {
                    en=0.0;
                }
                if(f<0.0)
                {
                    f=0.0;
                }
                if(hu<0.0)
                {
                    hu=0.0;
                }
                if(hy<0.0)
                {
                    hy=0.0;
                }
                
                
 
                ML_line(20,7,en+20,7,1);
                ML_line(20,8,en+20,8,1);
                
                ML_line(20,21,eq+20,21,1);
                ML_line(20,22,eq+20,22,1);
                
                ML_line(20,35,f+20,35,1);
                ML_line(20,36,f+20,36,1);
                
                ML_line(20,49,hy+20,49,1);
                ML_line(20,50,hy+20,50,1);
                
                ML_line(29,57,hu+29,57,1);
                key=0;
                GetKey(&key);
                break;
                
        }
    }
    RTC_GetTime(&hours, &mins, &secs, &msecs);
    timeactu[0]=hours;
    timeactu[1]=mins;
    timeactu[2]=secs;
    timeactu[3]=msecs;
    for(i==0;i<4;i++)
    {
        timeecou[i]=timeactu[i]-timeref[i];
        timeref[i]=timeactu[i];
    }
    Bfile_DeleteFile(Points);
    Bfile_DeleteFile(PathName);
    Bfile_CreateFile(Points,sizeof(points));
    Bfile_CreateFile(PathName,sizeof(timeref));
    fd=Bfile_OpenFile(PathName, _OPENMODE_WRITE);
    Bfile_WriteFile(fd, &timeref, sizeof(timeref));
    Bfile_CloseFile(fd);
    fdbis=Bfile_OpenFile(Points, _OPENMODE_WRITE);
    Bfile_WriteFile(fdbis, &points, sizeof(points));
    Bfile_CloseFile(fdbis);
    return 1;
}

int emotion(double tableau[5])
{
    if (tableau[0]>=25.0 && tableau[1]>=25.0 && tableau[2]>=25.0 && tableau[3]>=25.0 && tableau[4]>=25.0)return 0;
    
    if (tableau[0]<25.0)return 1;
    
    if(tableau[1]<25,0)return 2;
    
    if(tableau[2]<25.0)return 3;
    
    if(tableau[3]<25.0)return 4;
    
    if(tableau[4]<25.0)return 5;
    
    if(tableau[0]==-50.0 && tableau[1]==-50.0 && tableau[2]==-50.0 && tableau[3]==-50.0 && tableau[4]==-50.0)return 6;
    
    
}
int manger()
{
    numero=1;
    key=0;
    while(key!=KEY_CTRL_F1 && key!=KEY_CTRL_F6)
    {
    ML_clear_vram();
        ML_bmp_or(menu,64,0,64,64);
        ML_bmp_or(chatnormal,9,7,50,50);
        ML_bmp_or(bouffe[numero-1],71,15,50,50);
        key=0;
    GetKey(&key);
    switch(key)
    {
        case KEY_CTRL_LEFT:
            numero--;
            if(numero==0)
            {
                numero=6;
            }
            break;
        case KEY_CTRL_RIGHT:
            numero++;
            if(numero==7)
            {
                numero=1;
            }
            break;
        case KEY_CTRL_F1:
            return numero;
            break;
        case KEY_CTRL_F6:
            return 0;
            break;
    }
        
        ML_display_vram();
    }
}
int sentiment(double tableau[5])
{
    if (tableau[0]<50.0)
    {
        return 1;
    }
    if(tableau[1]<50.0)
    {
        return 2;
    }
    if(tableau[2]<50.0)
    {
        return 3;
    }
    if(tableau[3]<50.0)
    {
        return 4;
    }
    if(tableau[4]<50.0)
    {
        return 5;
    }
    return 0;
}
int jeux()
{
    
    numero=1;
    key=0;
    while(key!=KEY_CTRL_F1 && key!=KEY_CTRL_F6)
    {
        ML_clear_vram();
        ML_bmp_or(menu,64,0,64,64);
        ML_bmp_or(chatnormal,9,7,50,50);
        switch(numero)
        {
            case 1:
                ML_bmp_or(Jballes,71,15,50,50);
                break;
                
        }
        key=0;
        GetKey(&key);
        switch(key)
        {
            case KEY_CTRL_LEFT:
                numero--;
                if(numero==0)
                {
                    numero=1;
                }
                break;
            case KEY_CTRL_RIGHT:
                numero++;
                if(numero==2)
                {
                    numero=1;
                }
                break;
            case KEY_CTRL_F1:
                return numero;
                break;
            case KEY_CTRL_F6:
                return 0;
                break;
        }
        
        ML_display_vram();
    }
}

int jeu_balle()
{
    

    int x=0,y=0,vie=3,abs=64,fin=0,pts=0;
    while (vie>0)
    {
        ML_clear_vram();
        x=(rand() % (118 - 10) + 10);
        y=0;
        key=0;
        fin=0;
        while(fin==0)
        {
            
            ML_clear_vram();
            ML_bmp_or(balle,x,y,8,8);
            ML_bmp_or(chat,abs,54,10,10);
            ML_display_vram();
            
            if(pts<=10)y=y+2;
            else y=y+4;
            Sleep(75);
            if (IsKeyDown(KEY_CTRL_LEFT))
            {
                if(pts<=10)abs=abs-3;
                else abs=abs-5;
                if(abs<0)abs=0;
            }
            if(IsKeyDown(KEY_CTRL_RIGHT))
            {
                if(pts<=10)abs=abs+3;
                else abs=abs+5;
                if(abs>118)abs=118;
            }
            
            if((abs>=x-5 && abs<=x+5) && y>54)
            {
                fin=1;
                pts++;
            }
            if ((abs>x+10 || abs<x-10) && y>54)
            {
                ML_clear_vram();
                ML_bmp_or(balleE,x,y,8,8);
                ML_bmp_or(chat,abs,54,10,10);
                ML_display_vram();
                Sleep(100);
                
                ML_clear_vram();
                ML_bmp_or(balleE2,x,y,8,8);
                ML_bmp_or(chat,abs,54,10,10);
                ML_display_vram();
                Sleep(100);
                
                ML_clear_vram();
                ML_bmp_or(balleE3,x,y,8,8);
                ML_bmp_or(chat,abs,54,10,10);
                ML_display_vram();
                Sleep(100);

                
                ML_clear_vram();
                ML_bmp_or(balleE4,x,y,8,8);
                ML_bmp_or(chat,abs,54,10,10);
                ML_display_vram();
                Sleep(100);
                fin=1;
                vie--;
            }
            
        }
    
    
    
    }
    if(pts>10)pts=pts*3;
    return pts;
}
int douche()
{
    int a=0,i=0,coorX[500],coorY[500];
        ML_clear_vram();
        while(a<2)
        {
            a++;
            for(i=0;i<500;i++)
            {
                coorX[i]=(rand() % (100 - 30) + 30);
                coorY[i]=(rand() % (150 - (-150)) + (-150));
            }
            
            while(coorY[0]<40)
            {
                
                Sleep(50);
                ML_clear_vram();
                for(i=0;i<500;i++)
                {
                    ML_pixel(coorX[i],coorY[i],1);
                }
                ML_bmp_or(chatdort,39,7,50,50);
                ML_display_vram();
                for(i=0;i<500;i++)
                {
                    coorY[i]=(rand() % (coorY[i]+3 - coorY[i]+1) + coorY[i]+1);
                    
                }
            }
        }
return 0;
}
    
int accueil()
{
        

    ML_clear_vram();
    ML_bmp_or(debut,0,0,128,64);
    ML_display_vram();
    while(key!=KEY_CTRL_F1 && key!=KEY_CTRL_F6)
    {
        GetKey(&key);
    }
    if(key==KEY_CTRL_F1)
    {
        return 0;
    }
    else{
        return 1;
    }
}


//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

